var chartConfig = {
	autosize: true,
	fullscreen: true, //布尔值显示图表是否占用窗口中所有可用的空间。
	timezone: "Asia/Shanghai",
	container_id: "tv_chart_container",
	datafeed: new FeedBase(),
	library_path: "charting_library/",
	locale: "zh_TW",
	loading_screen: {
		"backgroundColor": "#fff",
		"foregroundColor": "#fff"
	},
	theme: 'Dark',
	disabled_features: [ // 需要屏蔽掉的 参考 https://tradingview.gitee.io/featuresets/
		"widget_logo",
		"header_widget",
		"use_localstorage_for_settings",
		"border_around_the_chart",
		"header_symbol_search",
		"header_resolutions",
		"header_interval_dialog_button",
		"show_interval_dialog_on_key_press",
		"header_chart_type",
		"header_compare",
		"header_undo_redo",
		"header_fullscreen_button",
		"header_saveload",
		"header_screenshot",
		"timeframes_toolbar",
		"go_to_date",
		"volume_force_overlay"
	],
	//禁用名称的数组
	enabled_features: [
		"hide_last_na_study_output",
		"move_logo_to_main_pane",
		"side_toolbar_in_fullscreen_mode",
		"hide_left_toolbar_by_default",
	],
	custom_css_url: "./css/tradingview.css",
	studies_overrides: {
		"volume.precision": 0,
		// 销量线
		"volume.volume.color.0": "#e15462",
		"volume.volume.color.1": "#65c892",
	},
	overrides: {
		"scalesProperties.lineColor": "#dfdfdf",
		"paneProperties.background": "#fff",
		"paneProperties.vertGridProperties.color": "rgba(255,255,255,0.05)",
		"paneProperties.horzGridProperties.color": "rgba(255,255,255,0.05)",
		"paneProperties.legendProperties.showLegend": true,
		"mainSeriesProperties.candleStyle": {
			upColor: "#00FFBB",
			downColor: "#E14646",
			drawBorder: true,
			borderColor: "#E14646",
			borderUpColor: "#00FFBB",
			borderDownColor: "#E14646",
			drawWick: true,
			wickColor: "#737375",
			wickUpColor: "#00FFBB",
			wickDownColor: "#E14646",
			barColorsOnPrevClose: false
		},
		"mainSeriesProperties.areaStyle.color1": "#f0b90b",
		"mainSeriesProperties.areaStyle.color2": "#fff",
		"mainSeriesProperties.areaStyle.linecolor": "#f0b90b",
		"mainSeriesProperties.areaStyle.linewidth": 2,
		"paneProperties.vertGridProperties.color": "#ebfded",
		"paneProperties.horzGridProperties.color": "#ebfded",
		//标记水印透明度
		"symbolWatermarkProperties.transparency": 0,
		//刻度属性文本颜色
		"scalesProperties.textColor": '#61688a',
		// 设置坐标轴字体大小
		'scalesProperties.fontSize': 10,
		//隐藏左上角行情信息
		'paneProperties.legendProperties.showLegend': false,
		'left_toolbar': false,
		//销量面板尺寸，支持的值: large, medium, small, tiny
		"volumePaneSize": "medium",
		"MACDPaneSize": "tiny",
		// 设置十字线
	}
	
}
