// import Event from './event.js'
var pako = window.pako
// 解压
function unzip(b64Data) {
	const strData = atob(b64Data);
	const charData = strData.split('').map(function(x) {
		return x.charCodeAt(0);
	});
	const binData = new Uint8Array(charData);
	const data = pako.inflate(binData);
	const array = new Uint16Array(data);
	// 防止一次解压造成内存溢出，这里进行分段解压
	let result = '';
	let i = 0;
	const maxRange = 8 * 1024;
	for (i = 0; i < array.length / maxRange; i++) {
		result += String.fromCharCode.apply(null, array.slice(i * maxRange, (i + 1) * maxRange));
	}
	result += String.fromCharCode.apply(null, array.slice(i * maxRange));
	return decodeURIComponent(result);
}

// 压缩
function zip(str) {
	return btoa(pako.gzip(encodeURIComponent(str), {
		to: 'string'
	}));
}
// 占用字节数计算(UTF-8)
function length(str) {
	let total = 0,
		charCode, i, len;
	for (i = 0, len = str.length; i < len; i++) {
		charCode = str.charCodeAt(i);
		if (charCode <= 0x007f) {
			total += 1;
		} else if (charCode <= 0x07ff) {
			total += 2;
		} else if (charCode <= 0xffff) {
			total += 3;
		} else {
			total += 4;
		}
	}
	return total;
}

function getQuery(name) {
	let reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	let r = window.location.search.substr(1).match(reg);
	if (r != null) {
		// 对参数值进行解码,避免中文乱码
		return decodeURIComponent(r[2]);
	}
	return null;
}

var socket = {
	socket: null, // socket name
	realTimeData: null, // 请求实时数据的参数
	intervalObj: null, // 定时器的名字
	lastRealTimeData: null, // 上一次请求的产品
	sendData(historyData, realTimeDatas, history) {

		// 储存历史数据
		this.historyData = historyData
		this.realTimeData = realTimeDatas
		// 如果上一次订阅过产品
		if (this.lastRealTimeData) {
			// 如果不是订阅历史产品 那么肯定就是切换周期咯 或者 切换产品
			// 那么就取消订阅上一次的产品实时数据
			if (!history) {
				// console.log('取消订阅' + this.lastRealTimeData)
				this.sendWsRequest({
					"cmd": 'sub',
					"topic": "kline.HKEX.00700.1.1m",
					"data": {},
				})
			}

			// 请求这一次的历史
			// this.sendWsRequest(this.historyData)

			// 如果不是订阅历史产品 那么肯定就是切换周期咯 或者切换产品咯 
			// 那么就订阅一下 这次产品的或者周期的 实时数据
			if (!history) {
				// console.log('订阅新的' + realTimeDatas)
				this.sendWsRequest({
					"cmd": 'sub',
					"topic": "kline.HKEX.00700.1.1m",
					"data": {},
				})
			}
		} else {
			// 如果是第一次订阅，就是说刚进入交易所，
			// 先存起来这一次请求的产品 作为历史产品
			this.lastRealTimeData = this.realTimeData
			// 然后 初始化一下websocket
			this.initWs()
		}
	},
	initWs() {
		this.socket = new WebSocket('ws://192.168.0.106:9999/ws')
		this.socket.onopen = () => {
			this.sendWsRequest({
				"cmd": 'sub',
				"topic": "kline.HKEX.00700.1.1m",
				"data": {},
			})
		}
		this.socket.onmessage = resp => {
			const klineDTOList = localStorage.getItem('klineDTOList');
			this.message(resp, klineDTOList)
		}
		this.socket.onclose = () => {
			this.close()
		}
		this.socket.onerror = err => {
			this.error(err)
		}
	},
	error(err) {
		console.log(err, 'depth-socket::error')
	},
	close() {
		// 如果websocket关闭的话，就从新打开一下。
		this.initWs()
		console.log('depth-socket::close')
	},
	message(resp, klineDTOList) {
		// let this_ = this
		if (resp.data instanceof Blob) {
			blob = resp.data;
			let result = '';
			let reader = new FileReader();
			reader.readAsBinaryString(blob);
			reader.onload = function() {
				result = JSON.parse(pako.inflate(reader.result, {
					to: 'string'
				}));
				//打印出返回的数据
				// console.log(result);
				// console.log((JSON.stringify(result));
			}

		}


		// let data = JSON.parse(pako.inflate(decodedString, {
		// 	to: 'string'
		// }));
		// console.log(data)
		// let msg = JSON.parse(resp.data)
		// if (msg.data && Array.isArray(msg.data)) {
		// 	const arr = msg.data.map(itme => {
		// 		return {
		// 			amount: itme.amount,
		// 			count: itme.count,
		// 			time: itme.time,
		// 			id: itme.time / 1000,
		// 			isBarClosed:true,
		// 			isLastBar:false,
		// 			volume: itme.vol,
		// 			vol: itme.vol,
		// 			close: itme.close,
		// 			open: itme.open,
		// 			high: itme.hight,
		// 			low: itme.low,
		// 		}
		// 	})
		// 	Event.emit('data', arr.reverse())
		// }
		// 如果是实时数据触发Event('realTime') 喂数据
		// if (msg.ticker) {
		// 	Event.emit('realTime', msg.ticker)
		// }
		//响应服务器，避免断开连接
		// if (msg.ping) {
		// 	this_.socket.send(JSON.stringify({
		// 		pong: msg.ping
		// 	}));
		// 	this_.hasCheck = true
		// }
		// this_.lastRealTimeData = this_.realTimeData
		// 如果是历史数据触发Event('data') 绘制数据


	},
	checkSendMessage(options) {
		// 这里处理websocket 连接不上的问题
		var checkTimes = 10
		var i = 0
		this.intervalObj = setInterval(() => {
			i += 1
			if (this.socket.readyState === 1) {
				// ...
				this.socket.send(options)
				clearInterval(this.intervalObj)
				return
			}
			if (i >= checkTimes) {
				clearInterval(this.intervalObj)
				console.log('send post_data_str timeout.')
			}
		}, 500)
	},
	sendWsRequest(options) {
		switch (this.socket.readyState) {
			case 0:
				this.checkSendMessage(JSON.stringify(options))
				break
			case 1:
				this.socket.send(JSON.stringify(options))
				break
			case 2:
				console.log('ws关闭状态')
				break
			case 3:
				this.initWs()
				break
			default:
				console.log('ws未知错误')
		}
	}
}

// export default socket
